//////////////////////////////////////////////////////////////////////////////////////////////
// Beispiel AnalogIN / AnalogOUT															//
//////////////////////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <conio.h>
#include <iostream>
#include <windows.h>
using namespace std;

#include "..\\Goldammer\\MAI_v2_DLL.h"
#if 1
// __stdcall
#pragma comment( lib, "..\\Goldammer\\LIB_STDCALL\\MAI_v2_WIN32_DLL" )
#else
// __cdecl
#pragma comment( lib, "..\\Goldammer\\LIB_CDECL\\MAI_v2_WIN32_DLL" )
#endif




int ErrorHandler(int CardID, int ErrorNumber);

int main()
{
	unsigned		int i					= 0;
	int				Result					= 0;
	int				Status					= 0;

	unsigned int	CardID					= 0;
	unsigned int	NumberOfADChannels		= 1;
	unsigned int	NumberOfDAChannels		= 1;
	unsigned int	Oversampling			= oversamplingDISABLED;
	unsigned int	Gain					= gainDisabled;
	unsigned int	polarity				= polBIPOLAR;
	double			Frequency				= 5000;
	double			Ausgabefrequenz			= 2048;
	unsigned int	StreamingMode			= smON;												

	
	unsigned int	DABlockSize				= 500;
	unsigned int	ADBlockSize				= 100;

	unsigned int	MaxValuesToGet			= 50000;
	unsigned int	CurrentNumberOfValues	= 0;
	unsigned int	PartBlock				= partONLYFULLBLOCKS;
	unsigned int	SkipData				= skipGETCAPTUREDVALUES;

	double		 *  ADData				    = 0;
	double		 *  DAData					= 0;

    


//////////////////////////////////////////////////////////////////////////////////////////////
// CardID der ersten, verfgbaren Karte ausgeben											//
//////////////////////////////////////////////////////////////////////////////////////////////
	CardID = GetFirstDevice();																// gibt die ID der ersten, angeschlossenen Karte zurck


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanallisten lschen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ClearAllChannelLists(CardID);													// lscht softwareseitig gehaltene Kanallisten
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanle der Kanalliste hinzufgen (AD + DA)												//
//////////////////////////////////////////////////////////////////////////////////////////////
	for (i = 0; i < NumberOfADChannels; i++)												// Kanle fr analoge Eingabe
	{
		Result = AD_AddChannelToList(	CardID,												// ID der anzusprechenden Karte
										i,													// Kanalnummer
										Oversampling,										// Funktion um Strungen des Messsignals zu reduzieren
										Gain,												// Verstrkungsfaktor
										polBIPOLAR  );											// wird vom Basic-Karten nicht untersttzt
		
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
	}
	
	for (i = 0; i < NumberOfDAChannels; i++)												// Kanle fr analoge Ausgabe
	{
		Result = DA_AddChannelToList(	CardID,												// ID der anzusprechenden Karte
										i  );												// Kanalnummer
		
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Frequenz setzen																			//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = AD_SetFrequency(	CardID,														// Frequenz fr die analoge Messung eingeben
								Frequency   );
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}

	Result = DA_SetFrequency(	CardID,														// analoge Ausgabefrequenz setzen
								Ausgabefrequenz );
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Parametrieren der Karte und Verarbeitung aller zuvor gettigten Eingaben / Einstellungen	//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ConfigMeasure(CardID);
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}

	ADData	    = new double[ADBlockSize];
	DAData		= new double[DABlockSize];

	memset(ADData, 0, ADBlockSize);
	memset(DAData, 0, DABlockSize);

	for (i = DABlockSize/2; i < DABlockSize; i++)
		DAData[i] = 32000 ;									// Beispielwerte fr die Ausgabe, 


//////////////////////////////////////////////////////////////////////////////////////////////
// Analoge Messung / Ausgabe anstarten														//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = StartMeasure(CardID);
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}

	Result = DA_StartOutput(CardID);
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}

	Status = 1;


//////////////////////////////////////////////////////////////////////////////////////////////
// Messdaten abholen / Analoge Werte ausgeben												//
//////////////////////////////////////////////////////////////////////////////////////////////
	while(CurrentNumberOfValues < MaxValuesToGet)											// Schleifenbedingung
	{
		if(_kbhit())	
			if (_getch()==27)																// Schleife mit "Escape" abbrechen
				break;
        unsigned int	ADBlockSizeTemp=0;
        AD_GetNumberOfValues(CardID,&ADBlockSizeTemp);

		if(ADBlockSizeTemp>ADBlockSize)
            ADBlockSizeTemp=ADBlockSize;                              // Blockgre wieder auf Anfangsgre
        for (i = 0; i < NumberOfADChannels; i++)	{
		    Result = AD_ReadData(	CardID,														// ID der anzusprechenden Karte
								    i,															// Nummer des Eintrages in die Kanalliste; im StreamingMode immer 0
								    NULL,													// Werte im 16Bit-Format
								    ADData,													// Scalierte Werte
								    &ADBlockSizeTemp,												// Blockgre zum Abholen der Werte / Nach Ausfhrung: Anzahl tatschlich gelesener Werte
								    PartBlock,													// 0 - es werden nur ganze Blcke geholt, 1 - Teilblcke
								    SkipData  );												// 0 - erfasste Daten werden in das Software-Fifo geschrieben, 1 - erfasste Daten werden verworfen
		    if (Result != 0){
			    ErrorHandler(CardID, Result);
			    StopMeasure(CardID);
			    DA_StopOutput(CardID);
			    system("Pause");
			    return 0;
		    }
        }

		CurrentNumberOfValues = CurrentNumberOfValues + ADBlockSizeTemp;

        unsigned int	DABlockSizeTemp			= 0;
        DA_GetFifoState(CardID,0,&DABlockSizeTemp);
        if(DABlockSizeTemp >= DABlockSize){
            for (i = 0; i < NumberOfDAChannels; i++)	{
																							        // fr Spannungswerte kann natrlich auch die Funktion DA_SetScaledData() verwendet werden
		        Result = DA_WriteScaledData(	CardID,													// ID der Karte
									        i,														// Nummer des Eintrages in die Kanalliste
									        DAData,												// 16-Bit Werte, die analog ausgegeben werden sollen
									        &DABlockSize,											// Anzahl der Werte, nach Ausfhrung: Anzahl tatschlich geschriebener Werte
									        0);														// 0 - ganze Blcke setzen; 1 - Teilblcke
		        if (Result != 0)
		        {
			        ErrorHandler(CardID, Result);
			        StopMeasure(CardID);
			        DA_StopOutput(CardID);
			        system("Pause");
			        return 0;
		        }
            }
        }
            cout << "\r " << CurrentNumberOfValues << "/" << MaxValuesToGet << " AD[0]:" << ADData[0];	
		Sleep(1);
	}

//////////////////////////////////////////////////////////////////////////////////////////////
// Analoge Eingabe / Ausgabe anhalten														//
//////////////////////////////////////////////////////////////////////////////////////////////

	
	Result = DA_StopOutput(CardID);															// analoge Ausgabe stoppen
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}
	
	Result = StopMeasure(CardID);															// analoge Messung stoppen
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}

	Status = 0;


															// Speicher freigeben
	delete[] ADData;																	//
	delete[] DAData;																		//

	
	cout << "\nFertig. \n ";
	system("Pause");
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
// Treten negative Rckgabewerte aufgerufener Funktionen auf, liegt ein Fehler vor.			//
// Mittels der ErrorHandler-Funktion wird eine Fehlerbeschreibung zurckgegeben.			//
//////////////////////////////////////////////////////////////////////////////////////////////
int ErrorHandler(int CardID, int ErrorNumber)
{
	char Descr[200];
	GetErrorDescription(CardID, ErrorNumber, Descr);
	cout << "Fehlernummer:  " << ErrorNumber << endl;
	cout << "Beschreibung:  " << Descr << endl;
	return ERROR_SUCCESS;
}
