//////////////////////////////////////////////////////////////////////////////////////////////
// Beispiel AnalogIN_Counter																//
//////////////////////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <conio.h>
#include <iostream>
#include <windows.h>

using namespace std;

#include "..\\Goldammer\\MAI_v2_DLL.h"
#if 1
// __stdcall
#pragma comment( lib, "..\\Goldammer\\LIB_STDCALL\\MAI_v2_WIN32_DLL" )
#else
// __cdecl
#pragma comment( lib, "..\\Goldammer\\LIB_CDECL\\MAI_v2_WIN32_DLL" )
#endif

int ErrorHandler(int CardID, int ErrorNumber);

int main()
{
	unsigned int	i						= 0;
	int				Result					= 0;
	int				Status					= 0;
	unsigned int	CardID					= 0;
	unsigned int 	NumberOfADChannels		= 2;
	unsigned int	NumberOfCTChannels		= 1;
	unsigned int	Oversampling			= oversamplingDISABLED;
	unsigned int	Gain					= gainDisabled;
	unsigned int	polarity					= polBIPOLAR;
	double			Frequency				= 1000;
	int				CounterMode				= cmIMPULSECOUNTER;
	unsigned int	StreamingMode			= smON;
	int				CapturedValues			= 0;
	unsigned int	ValuesPerChannel		= 100;
	unsigned int	ADBlockSize				= 0;
	unsigned int	CTBlockSize				= 0;
	unsigned int	ADBlockSizeTemp			= 0;
	unsigned int	CTBlockSizeTemp			= 0;
	unsigned int    ValuesInFifo			= 0;
	unsigned int	MaxValuesToGet			= 20000;
	unsigned int	CurrentNumberOfValues	= 0;
	unsigned int	PartBlock				= partONLYFULLBLOCKS;
	unsigned int	SkipData				= skipGETCAPTUREDVALUES;

	int			 *  RawData;
	double		 *  ScaledData;
	unsigned int *  CTData;





//////////////////////////////////////////////////////////////////////////////////////////////
// CardID der ersten, verfgbaren Karte ausgeben
//////////////////////////////////////////////////////////////////////////////////////////////
	CardID = GetFirstDevice();																// gibt die ID der ersten, angeschlossenen Karte zurck


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanallisten lschen
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ClearAllChannelLists(CardID);													// lscht softwareseitig gehaltene Kanallisten
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanle der Kanalliste hinzufgen
//////////////////////////////////////////////////////////////////////////////////////////////
	for (i = 0; i < NumberOfADChannels; i++)												// AD Kanle
	{
		Result = AD_AddChannelToList(	CardID,												// ID der anzusprechenden Karte
										i,													// Kanalnummer
										Oversampling,										// Funktion um Strungen des Messsignals zu reduzieren
										Gain,												// Verstrkungsfaktor
										polBIPOLAR  );											// wird vom Basic-Karten nicht untersttzt
		if (Result != 0)																	// Fehler
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
	}


	for (i = 0; i < NumberOfCTChannels; i++)												// CT Kanle der Kanalliste hinzufgen
	{
		Result = CT_AddChannelToList(	CardID,												// ID der verwendeten Karte
										i ,													// Zhlerkanal
										true);												// synchron zur AD Kanalliste
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
	}

	switch(CounterMode)																		// Zhlertyp bestimmen
	{
	case cmFREQUENCYCOUNTER:
		Result = CT_FrequencyCounter(CardID, 0, 0, 0, 0);									// Parametererklrung siehe Hilfe oder CounterDemo
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
		break;
	case cmPERIODCOUNTER:
		Result = CT_PeriodCounter(CardID, 0, 0, 0, 0);
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
		break;
	case cmPULSWIDTHCOUNTER:
		Result = CT_PulswidthCounter(CardID, 0, 0, 0, 0);
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
		break;
	case cmINCREMENTALCOUNTER:
		Result = CT_IncrementalCounter(CardID, 0, 0, 0, 0, 0, 0, 0);
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
		break;
	default:																				// ImpulseCounter
		Result = CT_ImpulseCounter(CardID, 0, 0, 0, 0);
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
		break;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Frequenz setzen
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = AD_SetFrequency(	CardID,														// Analoge Ausgabefrequenz eingeben
								Frequency   );												// Abtastrate pro Kanal
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Einstellung fr sptere Messwerterfassung												//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = SetStreamingMode(CardID, StreamingMode);										// if (StreamingMode == 1) --> User muss sich um das Zerreien der Daten kmmern
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}

	ADBlockSize	= ValuesPerChannel * NumberOfADChannels;									// Blockgre in Abhngigkeit der ADKanalanzahl anpassen
	CTBlockSize = ValuesPerChannel * NumberOfCTChannels;									//

	RawData		= new int[ADBlockSize];														// Speicher allokieren
	ScaledData	= new double[ADBlockSize];
	CTData		= new unsigned int[CTBlockSize];

	memset(RawData, 0, ADBlockSize);
	memset(ScaledData, 0, ADBlockSize);
	memset(CTData, 0, CTBlockSize);

	ADBlockSizeTemp = ADBlockSize;															// Blockgren zwischenspeichern
	CTBlockSizeTemp = CTBlockSize;


//////////////////////////////////////////////////////////////////////////////////////////////
// Parametrieren der Karte und Verarbeitung aller zuvor gettigten Eingaben/Einstellungen	//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ConfigMeasure(CardID);															
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Messung anstarten																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = StartMeasure(CardID);	
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}

	Status = 1;																				// Messung luft


//////////////////////////////////////////////////////////////////////////////////////////////
// Messdaten abholen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	while(CurrentNumberOfValues < MaxValuesToGet)											// Schleife wird solange ausgefhrt, bis gewnschter Endwert an Werten erreicht wird
	{
		if(_kbhit()) 
			if (_getch()==27)																// ... oder die Taste "Escape" gedrckt wird
				break;

		ADBlockSize = ADBlockSizeTemp;
		CTBlockSize = CTBlockSizeTemp;

		Result = AD_GetNumberOfValues(CardID, &ValuesInFifo);								// Rckgabewert enspricht der Anzahl vorhandener AD-Werte
		if (Result != 0)	
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}

		if (ValuesInFifo)
		{																					// tritt kein Fehler auf, entspricht der Rckgabewert der gelesenen Werte
			Result = AD_ReadData(CardID, 
								0,															// da Messung im StreamingMode luft, ist dieser Wert auf "0" zu setzen
								RawData, 
								ScaledData, 
								&ADBlockSize, 
								PartBlock, 
								SkipData);
			if (Result != 0)
			{
				ErrorHandler(CardID, Result);
				system("Pause");
				return 0;
			}
			CurrentNumberOfValues = CurrentNumberOfValues + ADBlockSize;					// Zhlwert fr Bedingung fr das Beenden der Schleifenende
		}

		Result = CT_GetNumberOfValues(CardID, &ValuesInFifo);
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}

		if (ValuesInFifo)
		{
			Result = CT_ReadData(CardID, 
								0, 
								CTData, 
								&CTBlockSize,												// Abzuholende Blockgre, nach Ausfhrung: Anzahl tatschlich gelesener Werte
								PartBlock, 
								SkipData);
			if (Result != 0)
			{
				ErrorHandler(CardID, Result);
				system("Pause");
				return 0;
			}
		}

		cout << "\r" << CurrentNumberOfValues << "/" << MaxValuesToGet << "    AD0: " << ScaledData[0] << "   AD1: " << ScaledData[1] << "    CT0: " << CTData[0];
		Sleep(1);
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Messung anhalten																			//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = StopMeasure(CardID);
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}
	Status = 0;


	delete[] RawData;																		// Speicher freigeben
	delete[] ScaledData;
	delete[] CTData;

	RawData		= 0;
	ScaledData	= 0;
	CTData		= 0;

	cout << "\nFertig. \n ";
	system("Pause");
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
// Treten negative Rckgabewerte aufgerufener Funktionen auf, liegt ein Fehler vor.			//
// Mittels der ErrorHandler-Funktion wird eine Fehlerbeschreibung zurckgegeben.			//
//////////////////////////////////////////////////////////////////////////////////////////////
int ErrorHandler(int CardID, int ErrorNumber)
{
	char Descr[200];
	GetErrorDescription(CardID, ErrorNumber, Descr);
	cout << "Fehlernummer:  " << ErrorNumber << endl;
	cout << "Beschreibung:  " << Descr << endl;
	return ERROR_SUCCESS;
}
