//////////////////////////////////////////////////////////////////////////////////////////////
// Beispiel AnalogIN_ExternStart															//
//////////////////////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <conio.h>
#include <iostream>

#include <windows.h>

using namespace std;

#include "..\\Goldammer\\MAI_v2_DLL.h"
#if 1
// __stdcall
#pragma comment( lib, "..\\Goldammer\\LIB_STDCALL\\MAI_v2_WIN32_DLL" )
#else
// __cdecl
#pragma comment( lib, "..\\Goldammer\\LIB_CDECL\\MAI_v2_WIN32_DLL" )
#endif




int ErrorHandler(int CardID, int ErrorNumber);

int main()
{
	unsigned int	i						= 0;
	int				Result					= 0;
	int				Status					= 0;
	unsigned int	CardID					= 0;
	unsigned int	NumberOfADChannels		= 4;
	unsigned int	Oversampling			= oversamplingDISABLED;
	unsigned int	Gain					= gainDisabled;
	unsigned int	polarity				= polBIPOLAR;
	double			Frequency				= 5000;
	unsigned int	ValuesInFifo			= 0;
	int				CapturedValues			= 0;
	unsigned int 	ValuesPerChannel		= 500;											// Richtwert: 1/10 der Frequenz
	unsigned int	MaxValuesToGet			= 100000;
	unsigned int	CurrentNumberOfValues	= 0;
	unsigned int	PartBlock				= partONLYFULLBLOCKS;
	unsigned int	SkipData				= skipGETCAPTUREDVALUES;

	int			 *  RawData					= 0;
	double		 *  ScaledData				= 0;
	double		 *  Anzeige					= 0;



//////////////////////////////////////////////////////////////////////////////////////////////
// CardID der ersten, verfgbaren Karte ausgeben											//
//////////////////////////////////////////////////////////////////////////////////////////////
	CardID = GetFirstDevice();																// gibt die ID der ersten, angeschlossenen Karte zurck


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanallisten lschen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ClearAllChannelLists(CardID);													// lscht softwareseitig gehaltene Kanallisten
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanle der Kanalliste hinzufgen															//
//////////////////////////////////////////////////////////////////////////////////////////////
	for (i = 0; i < NumberOfADChannels; i++)
	{
		Result = AD_AddChannelToList(	CardID,												// ID der anzusprechenden Karte
										i,													// Kanalnummer
										Oversampling,										// Funktion um Strungen des Messsignals zu reduzieren
										Gain,												// Verstrkungsfaktor
										polBIPOLAR  );											// wird vom Basic-Karten nicht untersttzt
		
		if (Result != 0)																		// Fehler
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Frequenz setzen																			//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = AD_SetFrequency(	CardID,														// Analoge Ausgabefrequenz eingeben
								Frequency   );
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Parametrieren der Karte fr eine(n) externe(n) Triggerung / Takt							//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ConfigCard(CardID, trigEXTERN_TRIGGER,  tedgeFALLING_EDGE, 0, 0);
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Parametrieren der Karte und Verarbeitung aller zuvor gettigten Eingaben/Einstellungen	//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ConfigMeasure(CardID);															
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}

	RawData		= new int[ValuesPerChannel];										// Speicher allokieren
	ScaledData	= new double[ValuesPerChannel];
	Anzeige		= new double[NumberOfADChannels];

	memset(RawData, 0, ValuesPerChannel);
	memset(ScaledData, 0, ValuesPerChannel);
	memset(Anzeige, 0, NumberOfADChannels);


//////////////////////////////////////////////////////////////////////////////////////////////
// Messung anstarten																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = StartMeasure(CardID);															// Messung wird auf der Karte erst nach einem Triggerereignis gestartet
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}
	Status = 1;																				// Messung luft
	
	cout << "Measurement started. Waiting for extern Trgger (hit <ESC> to quit) ...";

//////////////////////////////////////////////////////////////////////////////////////////////
// Messdaten abholen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	while(CurrentNumberOfValues < MaxValuesToGet)											// Schleife wird solange ausgefhrt, bis gewnschter Endwert an Werten erreicht wird
	{
		if(_kbhit()) 
			if (_getch()==27)																// ... oder die Taste "Escape" gedrckt wird
				break;

		Result = AD_GetNumberOfValues(CardID, &ValuesInFifo);										// gibt Anzahl der in den Fifos befindlichen Werte zurck
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}

		if ((unsigned int)ValuesInFifo >= ValuesPerChannel)									// Wenn ausreichend Werte vorhanden
		{
			for (i = 0; i < NumberOfADChannels; i++)										// Kanalweise Abholung der Werte aus den jeweiligen AD-Fifos
			{
				Result = AD_ReadData(	CardID,												// ID der verwendeten Karte 
										i,													// Nummer des Kanallisteneintrages (Grund: Wird ein Kanal mehrmals in die Kanalliste aufgenommen, muss zur Unterscheidung die Nummer des Kanallisteneintrages angegeben werden.)
										RawData,											// Daten im 16Bit-Format
										ScaledData,											// Skalierte Daten
										&ValuesPerChannel,									// Anzahl der Werte, nach Ausfhrung: Erfolgreich gelesene Werte
										PartBlock,											// Ganze Blcke / Teilblcke	(0 - ganz , 1 - teil)
										SkipData    );										// Erfasste Werte verwerfen		(0 - false, 1 - true)
				if (Result != 0)
				{
					ErrorHandler(CardID, Result);
					StopMeasure(CardID);
					system("Pause");
					return 0;
				}
				
				Anzeige[i] = ScaledData[0];
				CurrentNumberOfValues = CurrentNumberOfValues + ValuesPerChannel;
			}
			// lediglich der erste Werte eines jeden Kanals soll auf der Konsole ausgegeben werden 
			cout << "\r" << CurrentNumberOfValues << "/" << MaxValuesToGet << "   " << Anzeige[0] << "   " << Anzeige[1] << "   " << Anzeige[2] << "   " << Anzeige[3];
			
		}
		Sleep(1);
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Messung anhalten																			//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = StopMeasure(CardID);
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}
	Status = 0;


	delete[] RawData;
	delete[] ScaledData;
	delete[] Anzeige;

	RawData		= 0;
	ScaledData	= 0;
	Anzeige		= 0;

	cout << "\nFertig. \n ";
	system("Pause");
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
// Treten negative Rckgabewerte aufgerufener Funktionen auf, liegt ein Fehler vor.			//
// Mittels der ErrorHandler-Funktion wird eine Fehlerbeschreibung zurckgegeben.			//
//////////////////////////////////////////////////////////////////////////////////////////////
int ErrorHandler(int CardID, int ErrorNumber)
{
	char Descr[200];
	GetErrorDescription(CardID, ErrorNumber, Descr);
	cout << "Fehlernummer:  " << ErrorNumber << endl;
	cout << "Beschreibung:  " << Descr << endl;
	return ERROR_SUCCESS;
}
