//////////////////////////////////////////////////////////////////////////////////////////////
// Beispiel CardAttributes																	//
//////////////////////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <conio.h>
#include <iostream>

#include <windows.h>

using namespace std;

#include "..\\Goldammer\\MAI_v2_DLL.h"
#if 1
// __stdcall
#pragma comment( lib, "..\\Goldammer\\LIB_STDCALL\\MAI_v2_WIN32_DLL" )
#else
// __cdecl
#pragma comment( lib, "..\\Goldammer\\LIB_CDECL\\MAI_v2_WIN32_DLL" )
#endif



int main()
{
	int				tmpCardID			= 0;
	unsigned int	CardID				= 0;
	int				Result				= 0;

	char			SystemVersion[10];
	int				ControllerFwVersion	= 0;
	int				MPVersion			= 0;
	const char *	MAIVersion			= 0;
	const char *	CardName			= 0;
	const char *	CardProducer		= 0;
	const char *	CardSeller			= 0;
	const char *	ManufactureName		= 0;
	const char *	SerialNumber		= 0;
	const char *	CustomerName		= 0;
	const char *	CustomerNumber		= 0;
	const char *	CustomerPurchase	= 0;

	int				ADNumberOfChannels	= 0;
	int				ADSampleRate		= 0;
	int				ADSampleWidth		= 0;
	int				DANumberOfChannels	= 0;
	int				DASampleRate		= 0;
	int				DASampleWidth		= 0;
	int				TTLNumberOfChannels	= 0;
	int				TTLSampleRate		= 0;
	int				TTLSampleWidth		= 0;
	int				CTNumberOfChannels	= 0;
	int				CTSampleRate		= 0;
	int				CTSampleWidth		= 0;




//////////////////////////////////////////////////////////////////////////////////////////////
// CardID der ersten, verfgbaren Karte ausgeben											//
//////////////////////////////////////////////////////////////////////////////////////////////
	tmpCardID = GetFirstDevice();															// gibt die ID der ersten, angeschlossenen Karte zurck
	if (tmpCardID < 0)																		// wenn der Rckgabewert negativ ist --> Fehler
	{
		cout << "Fehler: Karte nicht gefunden.\n" << endl;
		system("Pause");
		return 0;
	}
	else
		CardID = tmpCardID;																	// ID zuweisen


//////////////////////////////////////////////////////////////////////////////////////////////
// Versionsnummern auslesen			 														//
//////////////////////////////////////////////////////////////////////////////////////////////
	MAIVersion = GetLIBVersion();															// Version des verwendeten Treibers
	GetSystemDriverVersion(CardID, SystemVersion);											// Systemtreiberversion
	ControllerFwVersion	= GetControllerFirmwareVersion(CardID);								// ControllerVersion
	MPVersion = GetMeasurementProcessorVersion(CardID);										// Version des MeasurementProcessors
	CardName = GetCardName(CardID);															// Kartenname
	CardProducer = GetCardProducer(CardID);													// Hersteller
	CardSeller = GetCardSeller(CardID);														// Verkufer
	ManufactureName = GetManufacture_Name(CardID);											// Kartentyp
	SerialNumber = GetSerialNumber(CardID);													// Seriennummer
	CustomerName = GetCustomer_Name(CardID);												// Name des Kufers
	CustomerNumber = GetCustomer_Number(CardID);											// Kufernummer
	CustomerPurchase = GetCustomer_DateOfPurchase(CardID);									// Datum des Verkaufs


//////////////////////////////////////////////////////////////////////////////////////////////
// Attribute abfragen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	ADNumberOfChannels = GetADChannels(CardID);												// Anzahl der analogen Eingabekanle auf der Karte
	ADSampleRate = GetADSampleRate(CardID);													// Summenabtastrate der AD-Kanle
	ADSampleWidth = GetADSampleWidth(CardID);												// Bitbreite der AD-Kanle
	DANumberOfChannels = GetDAChannels(CardID);												// Anzahl der analogen Ausgabekanle
	DASampleRate = GetDASampleRate(CardID);													// maximale Ausgabefrequenz der Karte
	DASampleWidth = GetDASampleWidth(CardID);												// Bitbreite der DA-Kanle
	TTLNumberOfChannels = GetTTLChannels(CardID);											// Anzahl der digitalen Kanle
	TTLSampleRate = GetTTLSampleRate(CardID);												// maximale Frequenz
	TTLSampleWidth = GetTTLSampleWidth(CardID);												// Bitbreite
	CTNumberOfChannels = GetCTChannels(CardID);												// Anzahl der Zhler
	CTSampleRate = GetCTSampleRate(CardID);													// Frequenz
	CTSampleWidth = GetCTSampleWidth(CardID);												// Bit


//////////////////////////////////////////////////////////////////////////////////////////////
// Ausgabe der Werte auf der Konsole														//
//////////////////////////////////////////////////////////////////////////////////////////////
	system("CLS");

	cout << "\n VERSIONSNUMMERN                                             (Seite 1/2)\n" << endl;
	cout << " Version der verwendeten MAI Lib:  " <<  MAIVersion << endl;
	cout << " Version des Systemtreibers     :  " << SystemVersion << endl;
	cout << " FirmwareVersion (Controller)   :  " << ControllerFwVersion << "  (" << hex << ControllerFwVersion << ")" << endl;
	cout << " MeasurementProcessorVersion    :  " << hex << MPVersion << "\n\n";
	cout << dec;
	cout << " Kartenname:        " << CardName << endl;
	cout << " Hersteller:        " << CardProducer << endl;
	cout << " Verkufer:         " << CardSeller << endl;
	cout << " Kartentyp:         " << ManufactureName << endl;
	cout << " Seriennummer:      " << SerialNumber << endl;
	cout << " Name des Kaeufers: " << CustomerName << endl;
	cout << " Kaeufernummer:     " << CustomerNumber << endl;
	cout << " Kaufdatum:         " << CustomerPurchase << "\n\n\n ";


	system("Pause");
	system("CLS");

	cout << "\n ANALOGE EINGABEKANAELE                                      (Seite 2/2)" << endl;
	cout << " Anzahl:           " << ADNumberOfChannels << endl;
	cout << " Summenabtastrate: " << ADSampleRate << " kHz" << endl;
	cout << " Bitbreite:        " << ADSampleWidth << " Bit\n\n";
	cout << " ANALOGE AUSGABEKANAELE" << endl;
	cout << " Anzahl:           " << DANumberOfChannels << endl;
	cout << " Ausgabefrequenz:  " << DASampleRate << " kHz" << endl;
	cout << " Bitbreite:        " << DASampleWidth << " Bit\n\n";
	cout << " DIGITALE KANAELE" << endl;
	cout << " Anzahl:           " << TTLNumberOfChannels << endl;
	cout << " SampleRate:       " << TTLSampleRate << " kHz" << endl;
	cout << " Bitbreite:        " << TTLSampleWidth << " Bit\n\n";
	cout << " ZAEHLER" << endl;
	cout << " Anzahl:           " << CTNumberOfChannels << endl;
	cout << " SampleRate:       " << CTSampleRate << endl;
	cout << " Bitbreite:        " << CTSampleWidth << " Bit\n\n\n ";


	system("Pause");
	return 0;
}