//////////////////////////////////////////////////////////////////////////////////////////////
// Beispiel Counter																			//
//////////////////////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <conio.h>
#include <iostream>
#include <windows.h>

using namespace std;

#include "..\\Goldammer\\MAI_v2_DLL.h"
#if 1
// __stdcall
#pragma comment( lib, "..\\Goldammer\\LIB_STDCALL\\MAI_v2_WIN32_DLL" )
#else
// __cdecl
#pragma comment( lib, "..\\Goldammer\\LIB_CDECL\\MAI_v2_WIN32_DLL" )
#endif


int ErrorHandler(int CardID, int ErrorNumber);

int main()
{
	unsigned int	i						= 0;
	int				Result					= 0;
	int				Status					= 0;
	unsigned int	CardID					= 0;
	unsigned int 	NumberOfCTChannels		= 2;
	double			Frequency				= 1000;
	unsigned int	ZaehlerModus			= cmIMPULSECOUNTER;
	int				ValuesInFifo			= 0;
	int				CapturedValues			= 0;
	unsigned int	ValuesPerChannel		= 100;
	unsigned int	BlockSize				= ValuesPerChannel;
	unsigned int	BlockSizeTemp			= 0;
	unsigned int	MaxValuesToGet			= 20000;
	unsigned int	CurrentNumberOfValues	= 0;
	unsigned int  * CTData					= 0;
	unsigned int  * CTAnzeige				= 0;


//////////////////////////////////////////////////////////////////////////////////////////////
// CardID der ersten, verfgbaren Karte ausgeben											//
//////////////////////////////////////////////////////////////////////////////////////////////
	CardID = GetFirstDevice();																// gibt die ID der ersten, angeschlossenen Karte zurck
	if (CardID < 0)
	{
		ErrorHandler(CardID, CardID);
		system("Pause");
		return 0;
	}
//////////////////////////////////////////////////////////////////////////////////////////////
// Kanallisten lschen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ClearAllChannelLists(CardID);													// lscht softwareseitig gehaltene Kanallisten
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanle der Kanalliste hinzufgen und Zhlermodi einstellen								//
//////////////////////////////////////////////////////////////////////////////////////////////
	for (i = 0; i < NumberOfCTChannels; i++)
	{
		Result = CT_AddChannelToList(	CardID,												// ID der verwendeten Karte
										i ,													// Zhlerkanal
										false);												// synchron zur AD Kanalliste
		
		if (Result != 0)																	// Fehler
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
	}


	for (i = 0; i < NumberOfCTChannels; i++)												// Zhler programmieren
	{
		switch(ZaehlerModus)
		{
		case cmFREQUENCYCOUNTER:
			Result = CT_FrequencyCounter(	CardID,											// ID der verwendeten Karte
											i,												// Eintrag des Kanals in die Kanalliste
											0,												// Frequenzauflsung; 0 - 1Hz, 1 - 10Hz, 2 - 100Hz, 3 - 1000Hz									
											0,												// Flanke des zu triggernden Eingangssignals
											0);												// EachPeriod
			if (Result != 0)
			{
				ErrorHandler(CardID, Result);
				system("Pause");
				return 0;
			}
			break;
		case cmPERIODCOUNTER:
			Result = CT_PeriodCounter(		CardID,											// ID der Karte
											i,												// Kanallisteneintrag
											0,												// Frequenzauflsung
											0,												// Flanke
											0);												// EachPeriod
			if (Result != 0)
			{
				ErrorHandler(CardID, Result);
				system("Pause");
				return 0;
			}
			break;
		case cmPULSWIDTHCOUNTER:
			Result = CT_PulswidthCounter(	CardID,											// ID
											i,												// Kanallisteneintrag
											0,												// Frequenzauflsung
											0,												// Flanke
											0);												// EachPeriod
			if (Result != 0)
			{
				ErrorHandler(CardID, Result);
				system("Pause");
				return 0;
			}
			break;
		case cmINCREMENTALCOUNTER:
			Result = CT_IncrementalCounter(	CardID,											// ID der verwendeten Karte
											i,												// Eintrag des Kanals in die Kanalliste
											0,												// Auflsung des HardwareCounters; beeinflut interne Auflsung zwischen 100ns und 20ns
											0,												// Flanke
											0,												// SoftwareReset setzt aktuellen Zhlwert zurck
											0,												// HardwareReset; 0 - Disabled, 1 - LevelMode, 2 - Extendet LevelMode, 3 - EdgeMode
											0,												// Flanke des Eingangssignals, auf die am Reseteingang getriggert werden soll
											0);												// Interpolation; 0 - 1x, 1 - 2x, 2 - 4x
			if (Result != 0)
			{
				ErrorHandler(CardID, Result);
				system("Pause");
				return 0;
			}
			break;
		default:
			Result = CT_ImpulseCounter(		CardID,											// ID der Karte 
											i,												// Eintrag des Kanals in die Kanalliste
											0,												// Startwert der Zhlermessung
											0,												// legt fest, ob hoch oder runter gezhlt werden soll
											0);												// Flanke
			if (Result != 0)
			{
				ErrorHandler(CardID, Result);
				system("Pause");
				return 0;
			}
			break;
		}
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Frequenz setzen																			//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = CT_SetFrequency(	CardID,														// ID der Karte											
								Frequency   );												// Zhlerfrequenz eingeben
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Parametrieren der Karte und Verarbeitung aller zuvor gettigten Eingaben/Einstellungen	//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ConfigMeasure(CardID);															
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}

	CTData = new unsigned int[BlockSize];													// Speicher allokieren
	CTAnzeige = new unsigned int[NumberOfCTChannels];

	memset(CTData, 0, BlockSize);
	memset(CTAnzeige, 0, NumberOfCTChannels);

	BlockSizeTemp = BlockSize;


//////////////////////////////////////////////////////////////////////////////////////////////
// Messung anstarten																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = StartMeasure(CardID);	
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}

	Status = 1;																				// Messung luft


//////////////////////////////////////////////////////////////////////////////////////////////
// Messdaten abholen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	while(CurrentNumberOfValues < MaxValuesToGet)											// Schleife wird solange ausgefhrt, bis gewnschter Endwert an Werten erreicht wird
	{
		if(_kbhit()) 
			if (_getch()==27)																// ... oder die Taste "Escape" gedrckt wird
				break;

		BlockSize = BlockSizeTemp;

		for (i = 0; i < NumberOfCTChannels; i++)											// Messwerte aus jedem KanalFifo abholen
		{
			Result = CT_ReadData(	CardID,													// ID der verwendeten Karte
									i,														// Kanallisteneintrag des auszulesenden Kanals
									CTData,													// Werte
									&BlockSize,												// Anzahl der zu holenden Werte, nach Ausfhrung: Anzahl der tatschlich gelesenen Werte
									0,														// Ganze Daten / Teildaten
									0	);													// Erfasste Werte verwerfen
			if (Result != 0)																// (Rckgabewert ungleich "0" --> Fehler
			{
				ErrorHandler(CardID, Result);
				StopMeasure(CardID);
				system("Pause");
				return 0;
			}
			CTAnzeige[i] = CTData[0];														// Werte in das AnzeigeArray schreiben
			CurrentNumberOfValues = CurrentNumberOfValues + BlockSize;						// zhlt die Anzahl der Werte
		}

		if (BlockSize)
			cout << "\r" << CurrentNumberOfValues << "/" << MaxValuesToGet << "    Counter[0]: " << CTAnzeige[0] << "    Counter[1]: " << CTAnzeige[1];
		Sleep(5);
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Messung anhalten																			//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = StopMeasure(CardID);
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}
	Status = 0;


	delete[] CTData;																		// Speicher freigeben
	delete[] CTAnzeige;

	CTData		= 0;
	CTAnzeige	= 0;

	cout << "\nFertig. \n ";

	system("Pause");
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
// Treten negative Rckgabewerte aufgerufener Funktionen auf, liegt ein Fehler vor.			//
// Mittels der ErrorHandler-Funktion wird eine Fehlerbeschreibung zurckgegeben.			//
//////////////////////////////////////////////////////////////////////////////////////////////
int ErrorHandler(int CardID, int ErrorNumber)
{
	char Descr[200];
	GetErrorDescription(CardID, ErrorNumber, Descr);
	cout << "Fehlernummer:  " << ErrorNumber << endl;
	cout << "Beschreibung:  " << Descr << endl;

	return ERROR_SUCCESS;
}
