//////////////////////////////////////////////////////////////////////////////////////////////
// Beispiel DigitalPort																		//
//////////////////////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <conio.h>
#include <iostream>

#include <windows.h>

using namespace std;

#include "..\\Goldammer\\MAI_v2_DLL.h"
#if 1
// __stdcall
#pragma comment( lib, "..\\Goldammer\\LIB_STDCALL\\MAI_v2_WIN32_DLL" )
#else
// __cdecl
#pragma comment( lib, "..\\Goldammer\\LIB_CDECL\\MAI_v2_WIN32_DLL" )
#endif


enum eOption { READPORT, WRITEPORT };

#define PortSize	4


int ErrorHandler(int CardID, int ErrorNumber);


int main()
{

	bool			Loop		= false;
	int				Result		= 0;
	int				CardIDtmp	= 0;
	unsigned int	CardID		= 0;
	int				Key			= 0;
	unsigned int	Port		= 1;														// auszulesender Port
	unsigned int	PortValue	= 0;
	unsigned int	PortChannel = 0;
	unsigned int	PortArray[PortSize];

	int				Options		= 0; 




//////////////////////////////////////////////////////////////////////////////////////////////
// CardID der ersten, verfgbaren Karte ausgeben											//
//////////////////////////////////////////////////////////////////////////////////////////////
	CardIDtmp = GetFirstDevice();															// gibt die ID der ersten, angeschlossenen Karte zurck
	if (CardIDtmp < 0)																		// keine Karte angeschlossen	
	{
		cout << "Keine Karte angeschlossen.\n\n\n";
		system("Pause");
		return 0;
	}
	else
	{
		Loop = true;
		CardID = CardIDtmp;
	}

	cout << "\n Options:\n --------\n (0)-ReadPort\n (1)-WritePort\n (2)-Beenden\n ";		// Men
	cin >> Options;

	if ((Options < 0) || (Options > 2))														// falsche Eingabe
		Options = 2;

	for(int i = 0; i < PortSize; i++)
		PortArray[i] = 0;																	// PortArray '0' setzen

	system("CLS");


//////////////////////////////////////////////////////////////////////////////////////////////
// DigitalPort setzen / auslesen															//
//////////////////////////////////////////////////////////////////////////////////////////////
	switch(Options)																			// je nach eingestellter Option
	{
	case READPORT:																			// Lesen eines digitalen Portes
		while(Loop)																			// Loop = true
		{
			if (_kbhit())
				if (_getch() == 27)															// wenn die "Escape"-Taste gedrckt wird 
				{
					Loop = false;															// --> Loop = False --> fhrt zur Beendigung der Schleife
					break;
				}

			Result = TTL_ReadPort(CardID, Port, &PortValue);											// Digitalen Port auslesen
			if (Result != 0)
			{
				ErrorHandler(CardID, Result);
				system("Pause");
				return 0;
			}

			for (int i = 0; i < PortSize; i++)
				PortArray[i] = (PortValue >> i) & 1;										// ausgelesenen Wert zuweisen und anschlieend anzeigen
	
			cout << "\rPort: " << Port << "   " << PortArray[3] << "  "  << PortArray[2] << "  " << PortArray[1] << "  "  << PortArray[0];
			Sleep(10);	
		}
		break;
	case WRITEPORT:																			// Setzen eines digitalen Portes
		while(Loop)
		{
			if (_kbhit())
			{
				Key = _getch();
				switch(Key)
				{
				case 27:																	// Taste Escape: dient zum Beenden des Programmes
					Loop = false;
					break;
				case 48:																	// Taste: 0
				case 49:																	// Taste: 1
				case 50:																	// Taste: 2
				case 51:																	// Taste: 3
					PortChannel = Key - 48;													// Kanal entspricht der gewhlten Taste

					switch(PortChannel)
					{
					case 0: PortArray[0] = ~(PortArray[0]) & 1; break;						// nderung des gewnschten Kanals vornehmen
					case 1: PortArray[1] = ~(PortArray[1]) & 1; break;
					case 2: PortArray[2] = ~(PortArray[2]) & 1; break;
					case 3: PortArray[3] = ~(PortArray[3]) & 1; break;
					default: break;
					}
				}
				
				PortValue = 0;
				
				for (int i = 0; i < PortSize; i++)											// PortValue prparieren
					PortValue = PortValue | (PortArray[i] << i); 
			}

			Result = TTL_WritePort(CardID, Port, PortValue);									// PortValue setzen
			if (Result != 0)
			{
				ErrorHandler(CardID, Result);
				system("Pause");
				return 0;
			}
			system("CLS");																	// Zur Kontrolle werden die Werte nochmals auf der Konsole ausgegeben
			cout << "PortValues:  " << ((PortValue >> 3) & 1) << "   "   << ((PortValue >> 2) & 1) << "   "   << ((PortValue >> 1) & 1) << "   "   << ((PortValue) & 1) << "     PortValue: " << PortValue;
			Sleep(10);
		}
	default:																				// fhrt zum Beenden dieses Beispiels
		break;
	}

	cout << "\nFertig. \n ";

	system("Pause");
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
// Treten negative Rckgabewerte aufgerufener Funktionen auf, liegt ein Fehler vor.			//
// Mittels der ErrorHandler-Funktion wird eine Fehlerbeschreibung zurckgegeben.			//
//////////////////////////////////////////////////////////////////////////////////////////////
int ErrorHandler(int CardID, int ErrorNumber)
{
	char Descr[200];
	GetErrorDescription(CardID, ErrorNumber, Descr);
	cout << Descr << endl;
	return ERROR_SUCCESS;
}
