unit UAnalogINOUT;

interface

implementation
uses
  SysUtils,
  ConsoleHelper,
  MAI_v2_DLL;

var
	CardID,  SizeOfLastBlockRead, NumberOfADValues, NumberOfDAValues, CurrentNumberOfValues,MaxValuesToGet,ValuesInFifo,FreeFifoSize: Cardinal;
  i,Result                : Integer;
  KeyThatWasPressed       : AnsiChar;
  RawData		              : array of Integer;
	ScaledData              : array of Double;
  DAValues                : array of Double;

begin
//////////////////////////////////////////////////////////////////////////////////////////////
//  Parameter der Messung	                                                       						//
//////////////////////////////////////////////////////////////////////////////////////////////


  NumberOfADValues		  := 2000;
  NumberOfDAValues		  := 20;
  MaxValuesToGet        := 1000000;
	SetLength(RawData,   NumberOfADValues);
	SetLength(ScaledData,NumberOfADValues);
  SetLength(DAValues,  NumberOfDAValues);
	for i := 0 to NumberOfDAValues-1 do
		DAValues[i] := -10.0 + i ;
//////////////////////////////////////////////////////////////////////////////////////////////
//  CardID der ersten, verfgbaren Karte verwenden	                             						//
//////////////////////////////////////////////////////////////////////////////////////////////
  CardID := GetFirstDevice();
	if (CardID < 0) then
	begin
		PrintError(CardID, CardID);
	 	Exit;
	end;

  WriteLn('Verwende Karte mit ID 0.');
  Writeln('Serial Number : '+GetSerialNumber(CardID));            // Seriennummer der Karte

  Result := ClearAllChannelLists(CardID) ;
  begin
			PrintError(CardID, Result);
      Exit;
	end;


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanle der Kanalliste hinzufgen									                             						//
//////////////////////////////////////////////////////////////////////////////////////////////

  Result := AD_AddChannelToList(	CardID,												// ID der anzusprechenden Karte
                                  0,												  	// Kanalnummer
                                  oversamplingDISABLED,				  // Funktion um Strungen des Messsignals zu reduzieren
                                  gainDisabled,									// Verstrkungsfaktor
                                  polBIPOLAR  );									// ein Wechsel der Polatitt wird vom Basic-Karten nicht untersttzt

  if (Result <> 0) then 																	      // Fehler prfen
  begin
    PrintError(CardID, Result);
    Exit;
  end;
 	Result := DA_AddChannelToList(	CardID,												// ID der anzusprechenden Karte
										                0   );												// Kanal / Kanallisteneintrag
  if (Result <> 0) then
  begin
    PrintError(CardID, CardID);
    Exit;
  end;

//////////////////////////////////////////////////////////////////////////////////////////////
// Samplefrequenz setzen																			                                    //
//////////////////////////////////////////////////////////////////////////////////////////////
	Result := AD_SetFrequency(	CardID,
								              50000   );											    	// Abtastrate pro Kanal
	if (Result <> 0) then 																		        // Fehler prfen
	begin 
	  PrintError(CardID, CardID);
	 	Exit;
	end;



//////////////////////////////////////////////////////////////////////////////////////////////
// Ausgabefrequenz festlegen																                                //
//////////////////////////////////////////////////////////////////////////////////////////////
	Result := DA_SetFrequency(	CardID,												 // ID der anzusprechenden Karte
								              20   );												 // Ausgabefrequenz
	if (Result <> 0) then
	begin
    PrintError(CardID, CardID);
    Exit;
	end;





//////////////////////////////////////////////////////////////////////////////////////////////
// Parametrieren der Karte und Verarbeitung aller zuvor gettigten Eingaben / Einstellungen //
//////////////////////////////////////////////////////////////////////////////////////////////
	Result := ConfigMeasure(CardID);
	if (Result <> 0) then
	begin
      PrintError(CardID, CardID);
	 	  Exit;
	end;


//////////////////////////////////////////////////////////////////////////////////////////////
// Messung anstarten																		                                    //
//////////////////////////////////////////////////////////////////////////////////////////////
	Result := StartMeasure(CardID);
	if (Result <> 0) then
	begin
     PrintError(CardID, CardID);
     Exit;
	end;

//////////////////////////////////////////////////////////////////////////////////////////////
// Ausgabe anstarten																                                        //
//////////////////////////////////////////////////////////////////////////////////////////////
	Result := DA_StartOutput(CardID);
	if (Result <> 0) then 
	begin 
    PrintError(CardID, CardID);
    Exit;
	end;


//////////////////////////////////////////////////////////////////////////////////////////////
// Messdaten abholen																		                                    //
//////////////////////////////////////////////////////////////////////////////////////////////

  CurrentNumberOfValues := 0;
	while (CurrentNumberOfValues < MaxValuesToGet) do 											// Bedingung fr Beendigung der Schleife
	begin
    if (KeyPressed(KeyThatWasPressed)) then
    begin
        if(KeyThatWasPressed = #27) then
        begin
           WriteLn('Sie haben <ESC> gedrueckt.');
				   break;
        end;

    end;
    Result := AD_GetNumberOfValues(CardID, ValuesInFifo);										// gibt Anzahl der in den Fifos befindlichen Werte zurck
		if (Result <> 0) then 
		begin
      PrintError(CardID, Result);
      break;
		end;

		if (ValuesInFifo >= NumberOfADValues) then 														// wenn gengend Werte vorliegen
		begin 

          SizeOfLastBlockRead :=  NumberOfADValues;

					Result := AD_ReadData(	CardID,											 // ID der verwendeten Karte
                                  0,												   // Nummer des Kanallisteneintrages (Grund: Wird ein Kanal mehrmals in die Kanalliste aufgenommen, muss zur Unterscheidung die Nummer des Kanallisteneintrages angegeben werden.)
                                  @RawData[0],								 // Rohdaten
                                  @ScaledData[0],							 // Skalierte Daten
                                  SizeOfLastBlockRead,				 // Anzahl der Werte
                                  partONLYFULLBLOCKS,						 // Ganze Blcke / Teilblcke	(0 - ganz , 1 - teil)
                                  skipGETCAPTUREDVALUES    );		 // Erfasste Werte verwerfen		(0 - false, 1 - true)
					if (Result <> 0) then
					begin
              PrintError(CardID, Result);
              break;
					end;

					CurrentNumberOfValues := CurrentNumberOfValues + SizeOfLastBlockRead;				// Zhler fr die Anzahl der erfassten Werte

      Write(Char(13)+'  ' + InttoStr( currentNumberOfValues )+ '/' + InttoStr( MaxValuesToGet )+'     Spannung: '+FloatToStrF( ScaledData[0],ffFixed, 4, 2));

      Sleep(1);
		end;

    Result := DA_GetFifoState(CardID, 0, FreeFifoSize);							// wieviel Platz ist im Fifo?
    if (Result <> 0) then
    begin
     PrintError(CardID, CardID);
     break;
    end;

    if (FreeFifoSize >=  NumberOfDAValues) then
    begin
      Result := DA_WriteScaledData(	CardID,									// CardID der verwendeten Karte
                                    0,											// Kanallisteneintrag des Kanals
                                    @DAValues[0],						// Werte
                                    NumberOfDAValues,				// Anzahl der Werte, nach der Ausfhrung: Anzahl tatschlich geschriebener Werte
                                    partONLYFULLBLOCKS  );		//
      if (Result <> 0) then
      begin
        PrintError(CardID, CardID);
        break;
      end;

    end;

	end;

//////////////////////////////////////////////////////////////////////////////////////////////
// Messung anhalten																			                                    //
//////////////////////////////////////////////////////////////////////////////////////////////
	Result := StopMeasure(CardID);
	if (Result <> 0) then
	begin
    PrintError(CardID, CardID);
    Exit;
	end;

//////////////////////////////////////////////////////////////////////////////////////////////
// Ausgabe anhalten																		                                     	//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result := DA_StopOutput(CardID);
	if (Result <> 0) then
	begin 
   PrintError(CardID, CardID);
   Exit;
	end;

  WriteLn;
  WriteLn;
  Writeln('Fertig. (Bitte <Enter> druecken...)');
  Read(KeyThatWasPressed);
end.
