unit UManipulateEEPROM;
interface

implementation

uses
  SysUtils,
  ConsoleHelper,
  MAI_v2_DLL;

function BitToStr( Int: Integer ): String;
var
  i, j: Integer;
begin
   Result := 'Low ';

  If Int > 0 then
    Result := 'High';

end;


Const
  MAX_CHARS = 256;

var
	CardID,EEPROMLength     : Cardinal;
  i,Result                : Integer;
  KeyThatWasPressed       : AnsiChar;
  NewEEPROMData           : AnsiString;
begin



//////////////////////////////////////////////////////////////////////////////////////////////
//  CardID der ersten, verfgbaren Karte verwenden	                             						//
//////////////////////////////////////////////////////////////////////////////////////////////
  CardID := GetFirstDevice();
	if (CardID < 0) then
	begin
		PrintError(CardID, CardID);
	 	Exit;
	end;

  WriteLn('Verwende Karte mit ID 0.');
  Writeln('Serial Number : '+GetSerialNumber(CardID));            // Seriennummer der Karte
  Writeln;
  Writeln;
  Writeln(' Optionen :   (1) EEProm auslesen');
  Writeln('              (2) EEProm beschreiben');
  Writeln('              (3) EEProm leeren');
  Writeln('              (0) beenden');
  while TRUE do
  begin
    if(KeyPressed(KeyThatWasPressed)) then
    begin
     if(( KeyThatWasPressed = Char('1')) OR (KeyThatWasPressed = Char('2'))  OR (KeyThatWasPressed = Char('3')) or (KeyThatWasPressed = Char('0'))) then
        break;
    end ;
    Sleep(100);
  end;
  Writeln;
  Writeln;
  if KeyThatWasPressed = Char('0')  then
    Exit;
  if KeyThatWasPressed = Char('1')  then     // READ
  begin
    SetLength(NewEEPROMData, MAX_CHARS);
		Result := PrivateFlashDataRead(CardID, PAnsiChar(NewEEPROMData), MAX_CHARS);		// auslesen
    if (Result <> 0) then
    begin
      PrintError(CardID, Result);
      Exit;
    end;
    Writeln('Flash-Inhalt:');
    Writeln(NewEEPROMData);
  end;
  if KeyThatWasPressed = Char('2')  then     // READ
  begin
    Write('Neuen Flash-Inhalt eingeben : ');
    Readln(NewEEPROMData);
    if(NewEEPROMData = '') then
        Exit;
    EEPROMLength := Length( PChar(NewEEPROMData));
    if(EEPROMLength > MAX_CHARS)   then
       EEPROMLength :=  MAX_CHARS;
		Result := PrivateFlashDataWrite(CardID,  PAnsiChar(NewEEPROMData), EEPROMLength);
    if (Result <> 0) then
    begin
      PrintError(CardID, Result);
      Exit;
    end;
  end;
  if KeyThatWasPressed = Char('3')  then     // READ
  begin
    Write('Wirlich alles loeschen (Ja/Nein)?');
    Readln(NewEEPROMData);
    if LowerCase(NewEEPROMData) <>  'ja' then
      Exit;
		Result := PrivateFlashDataClear(CardID);
    if (Result <> 0) then
    begin
      PrintError(CardID, Result);
      Exit;
    end;
    Writeln('Flash-Inhalt geloescht.');
  end;
  WriteLn;
  WriteLn;
  Writeln('Fertig. (Bitte <Enter> druecken...)');
  Read(KeyThatWasPressed);
end.
