unit UPWM;

interface

implementation

uses
  SysUtils,
  ConsoleHelper,
  MAI_v2_DLL;

function KeyIsPlus (Key: AnsiChar): Boolean;
begin
  Result := (Key = Char('+'));
end;
function KeyIsMinus (Key: AnsiChar): Boolean;
begin
  Result := (Key = Char('-'));
end;

var
	CardID,  ChannelNumber: Cardinal;
  Result                : Integer;
  KeyThatWasPressed     : AnsiChar;
  PWMRatio              : Cardinal;
begin



//////////////////////////////////////////////////////////////////////////////////////////////
//  CardID der ersten, verfgbaren Karte verwenden	                             						//
//////////////////////////////////////////////////////////////////////////////////////////////
  CardID := GetFirstDevice();
	if (CardID < 0) then
	begin
		PrintError(CardID, CardID);
	 	Exit;
	end;

  WriteLn('Verwende Karte mit ID 0.');
  Writeln('Serial Number : '+GetSerialNumber(CardID));            // Seriennummer der Karte
  Writeln;
  Writeln;

  if(GetPWMChannels(CardID)<1) then
  begin
    Writeln(' Diese Karte het keine PWM Kanle ');
    Writeln('(Bitte <Enter> druecken...)');
    Read(KeyThatWasPressed);
    Exit;
  end;

  Result := PWM_StartOutput(CardID);
  if (Result <> 0) then
  begin
    PrintError(CardID, Result);
    Exit;
  end;
  PWMRatio := 50;
  Result := PWM_PreparePWMOutput(CardID, 0, 1, PWMRatio);
  Writeln('Verwende Kanal 0 ');
  Writeln('Aendern der PWM Rate : + oder - druecken, <Esc> fuer Abbruch ');
  Writeln;
  Write(' Puls/Pause Rate:  ');
  Write(PWMRatio);

  while TRUE do
  begin
    if(KeyPressed(KeyThatWasPressed)) then
    begin
     if( KeyThatWasPressed = #27) then
        break;
     if(KeyIsPlus(KeyThatWasPressed) AND (PWMRatio < 100)) then
        Inc(PWMRatio);
     if(KeyIsMinus(KeyThatWasPressed) AND (PWMRatio > 0 )) then
        Dec(PWMRatio);
    end
    else
      Sleep(300);


    Result := PWM_WriteNewPWMRatio(CardID,0,PWMRatio);
    if (Result <> 0) then
    begin
        PrintError(CardID, Result);
        Break;
    end;
    Write(Char(13)+' Puls/Pause Rate:  ');
    Write(PWMRatio);

  end;



  Result := PWM_StopOutput(CardID);;
  if (Result <> 0) then
  begin
    PrintError(CardID, Result);
    Exit;
  end;
  WriteLn;
  WriteLn;
  Writeln('Fertig. (Bitte <Enter> druecken...)');
  Read(KeyThatWasPressed);
end.
 